new;

#define USE_QNEWTON

#ifdef USE_CO
  library option,pgraph,co;
#else
  #ifdef USE_OPTMUM
    library option,optmum,pgraph;
  #else
    library option,pgraph;
  #endif
#endif

OptionSet;

cls;

Strike = seqa(60,1,81);

let S0 = 100;

proc (2) = Skew(Kmin,SkewMin,Kmax,SkewMax);
  local Skew;

  if Kmax == 0;
    Skew = Kmin~SkewMin;
  else;
    Skew = Kmin~SkewMin |
           Kmax~SkewMax ;
  endif;

  retp(Skew[.,1],Skew[.,2]);
endp;

let K   =  90   100;
let Vol =  0.30 0.25;
let sv = 0.5 0.1 0.1;

let StrikeSkew = 70;
let pSkew = -0.01;

__output = 0;
_PDM_Weight = 0.01;
{a,b,c,d,m} = PDM_Calibrate(S0,K,Vol,Skew(StrikeSkew,pSkew,0,0),sv);
Smile = PDM_ImpVol(S0,Strike,a,b,c,d,m);

fn SmileFunction(K) = PDM_ImpVol(S0,K,a,b,c,d,m);
{Sigma,CDF,PDF} = Smile_to_Density(S0,Strike,&SmileFunction,1,0);
{cdf_ln,pdf_ln} = EuropeanBS_Density(S0,Strike,0.25,1,0);

graphset;
  begwind;
  makewind(9,6.855,0,0,1);
  makewind(4,4,4.75,2,0);

  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3;
  _plwidth = 10;
  xtics(60,140,20,2);

  setwind(1);
    title("\216Sk(70) = -100 bp");
    xlabel("\216Strike K");
    ytics(0.20,0.60,0.10,2);
    _psym = K~Vol~ones(2,1).*(11~8~0~1~0);
    xy(Strike,Smile);

  setwind(2);
    _ptitlht = 0.30; _paxht = 0.22; _pnumht = 0.22;
    _pcross = 1; _pbox = {1, 12, 10};
    title("\216Risk-Neutral PDF");
    xlabel("\216S");
    _plegstr = "Smiled Model\000ATM BS Model";
    _plegctl = {2 5 5.5 4};
    ytics(-0.02,0.08,0.02,2);
    xy(Strike,pdf~pdf_ln);

  endwind;


