new;
library option,pgraph;
optionSet;

rndseed 456; 

proc procMu(t,x);
  local mu;

  mu  = (5 - x[1])            |
        (t * (x[1] + x[2]))   ;

  retp(mu);
endp;

proc procSIGMA(t,x);
  local sigma;

  sigma =  0.75*x[1] ~      0     ~       0                 |
           x[1]   ~    x[2]    ~  sqrt((x[1]^2+x[2]^2))    ;

  retp(sigma);
endp;

let x0 = 1 4;
let rho[3,3] =   1   0.25   0
                 0   1     -0.10
                 0  -0.10   1;
t = qmc_Generate_t(0,1,501);
x = qmc_simulate_mSDE(x0,&procMu,&procSigma,rho,t,1);

graphset;
  _pdate = ""; _pnum = 2; _pltype = 6|3; _plwidth = 10; _pframe = 0;
  title("\216Simulations of a multi-dimensionnal SDE process");
  xlabel("\216t"); ylabel("\216x(t)");
  _plegstr = "x]1[(t)\000x]2[(t)";
  _plegctl = {2 7 1.8 4.8};
  xy(t,x);


