/*
**> Computing the implied RND of the SABR model
**
*/

new;

#ifdef USE_OPTMUM
  library option,pgraph,optmum;
#else
  library option,pgraph;
#endif

optionSet;

cls;

F0 = 0.05;
tau = 1;

let Strike = 0.04 0.05 0.08;
let ImpVol = 0.11 0.09 0.10;

K = seqa(0.02,0.001,81);

beta = 1;
{alpha,beta,nu,rho} = SABR_Calibrate(F0,Strike,ImpVol,beta,tau,0);
{ImpVol1,cdf1,pdf1} = sabr_pdf(F0,K,alpha,beta,nu,rho,tau);

beta = 0.0;
{alpha,beta,nu,rho} = SABR_Calibrate(F0,Strike,ImpVol,beta,tau,0);
{ImpVol2,cdf2,pdf2} = sabr_pdf(F0,K,alpha,beta,nu,rho,tau);

beta = 1;
{alpha,beta,nu,rho} = SABR_Calibrate(F0,Strike,ImpVol,beta,tau,0);
ATM = 0.12;
alpha = SABR_Calibrate_ATM(F0,ATM,beta,nu,rho,tau);
{ImpVol3,cdf3,pdf3} = sabr_pdf(F0,K,alpha,beta,nu,rho,tau);

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3; _plwidth = 10;
  xlabel("\216Strike (%)");
  xtics(3,7,1,2);
  ylabel("\216Risk-Neutral Density");
  _plegstr = "\202b\201 = 1\000\202b\201 = 0\000\202b\201 = 1, ATM = 9% -> ATM = 12%";
  _plegctl = {2 5 4 2};
  graphprt("-c=1 -cf=sabr6.eps");
  xy(100*K,pdf1~pdf2~pdf3);

